<?php
/* $Id: db_create.postgresql.php 113 2011-03-02 22:34:24Z mir $ */

function make_sql_stm() {
    $db = array();

    array_push($db, "create sequence roles_pk_seq");
    array_push($db, "create table roles (
    id integer primary key default nextval('roles_pk_seq'),
    name varchar(256) not null
    )");
    array_push($db, "insert into roles values(0,'administrator')");
    array_push($db, "insert into roles values(1,'power user')");
    array_push($db, "insert into roles values(2,'user')");

    array_push($db, "create sequence users_pk_seq");
    array_push($db, "create table users (
    id integer primary key default nextval('users_pk_seq'),
    uid varchar(256) not null,
    pwd varchar(256) not null,
    userrole integer not null,
    timeout integer default 3600,
    userview varchar(256) default 'week',
    weekstart integer default 0,
    daystart numeric(4,2) default 8.00,
    dayend numeric(4,2) default 17.00,
    timezone varchar(256) default 'Etc/UTC',
    seckey varchar(256) default '',
    pubkey varchar(256) default '',
    constraint uid_index unique (uid),
    constraint userrole_fk foreign key (userrole) references roles (id)
    on update cascade
    on delete restrict
    )");

    array_push($db, "create sequence calendar_pk_seq");
    array_push($db, "create table calendar (
    id integer default nextval('calendar_pk_seq'),
    uid integer not null,
    name varchar(256) not null,
    color varchar(256) default 'navy',
    config varchar(4000) default '',
    constraint calendar_pk primary key (id, uid),
    constraint uid_fk foreign key (uid) references users (id)
    on update cascade
    on delete cascade
    )");
    array_push($db, "create table about (
    id integer default 1,
    version varchar(256) default '')");
    array_push($db, "create table ldap (
    enable integer default 0,
    dns varchar(256) default '',
    tls integer default 0,
    base_dn varchar(256) default '',
    user_attr varchar(256) default 'uid')");

    return $db;
}
?>
